package com.care.mqtt.service;


import cn.hutool.core.bean.BeanUtil;
import com.care.mqtt.tool.MqttDataConnector;

import com.care.common.entity.CareDevice;
import com.care.mqtt.tool.MqttDataConnectorPool;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;

/**
 * @Author: stw
 * @Date: 2021/8/14
 * @Desc:
 */
@Service
public class MqttPublishService {
    @Resource
    private MqttConnectorPoolService mqttConnectorPoolService;


    /**
     * 发布消息
     */
    public boolean publish(CareDevice careDevice,String data) {
        try {

            CareDevice careDevicePublish = new CareDevice();
            BeanUtil.copyProperties(careDevice,careDevicePublish);

            String topic = careDevicePublish.getTopic();
            String cliendId = careDevicePublish.getClientId();
            if (StringUtils.isEmpty(topic) || StringUtils.isEmpty(cliendId)) {
                return false;
            }

            String publishTopic = topic.replace("event","control");
            String publishCliendId = cliendId + "_publish";

            MqttDataConnector mqttDataConnector = MqttDataConnectorPool.getMqttDataConnectorMap().get(publishCliendId);
            if (mqttDataConnector == null) {
                careDevicePublish.setTopic(publishTopic);
                careDevicePublish.setClientId(publishCliendId);
                mqttDataConnector = mqttConnectorPoolService.addOne(careDevicePublish);
            }

            mqttDataConnector.publish(publishTopic, data);

            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

}
